-- Best Seller Auto Sell

function bsAutoSell()

    bAutoSellActive=true;

local
					itemName,
                    itemLink,
                    itemRarity,
                    itemLevelReq,
                    itemMinLevel,
                    itemType,
                    itemSubType,
                    itemStackCount,
                    itemEquipLoc,
                    itemTexture,
                    itemSellPrice;

    local exclude=0;
	local floi=0;
	local isfood=0;
	local ifoodrange=0;
	local itotalgold=0;
	local dosoulbound=0;
	local dofood=0;
    local ttext="";
    local tiLevel="0";
    local iLevel=0;
    local safecount=0;
    local wildcard="";
    local bDoSell=0;
    local bIsSoulbound=0;
    local bIsQuestItem=0;
    local bIsRecipe=0;
    local bHasFoodBuf=0;

    if(db.AutoSell["Active"]) then
		for bag = 0,4,1 do
			for slot = 1, GetContainerNumSlots(bag), 1 do
				local name = GetContainerItemLink(bag,slot);
				if(name~=nil) then

                    bDoSell=0;
                    bIsQuestItem=0;
                    bIsSoulbound=0;
                    bHasFoodBuf=0;
                    bIsRecipe=0;

                    itemCount=GetItemCount(name);

					itemName,
                    itemLink,
                    itemRarity,
                    itemLevelReq,
                    itemMinLevel,
                    itemType,
                    itemSubType,
                    itemStackCount,
                    itemEquipLoc,
                    itemTexture,
                    itemSellPrice
                    = GetItemInfo(name);

                    BSTooltip:ClearLines();
                    BSTooltip:SetHyperlink(name);


                    for floi=1, BSTooltip:NumLines(),1 do

                        local amtext=getglobal("BSTooltipTextLeft" .. floi);

                        -- bsInform(amtext:GetText());

                        for tiLevel in string.gmatch(amtext:GetText(), "Item Level (.+)") do
                            iLevel=tiLevel;
                        end

                        if(string.find(amtext:GetText(),"Recipe:")) then
                            bIsRecipe=1;
                        end

                        if(string.find(amtext:GetText(),"well fed")) then
                            bHasFoodBuf=1;
                        end

                        if(amtext:GetText()=="Binds when picked up") then
                            if(floi==2) then
                                bIsSoulbound=1;
                            end
                        end
                    end

                    if(bIsRecipe==1) then
                        bHasFoodBuf=0;
                    end

                    -- TODO: Search quest log and compare items that you need for quests that aren't "Quest" items

                    bIsQuestItem=0;
                    if(itemType=="Quest") then
                        bIsQuestItem=1;
                    end

                    if(db.AutoSell["Safe"]==1) then
                        if(safecount>11) then
                            bsInform("SAFE MODE: Sold 12 items and now stopping");
                            return
                        end
                    end

                    exclude=0; -- exclude table will over ride "Items" to sell
                    for item,_ in pairs (db.AutoSell["Exclude"]) do
                        for what in string.gmatch(item, "(.+)*") do
                            if(what~=nil) then
                                -- bsDPrint("wildcard=["..what.."]");
                                wildcard=what;
                            end
                        end
                    end

                    for item,_ in pairs (db.AutoSell["Exclude"]) do
                        if(itemName==item) then
                            exclude=1;
                        end
                        if(wildcard~="") then
                            if(string.find(itemName,wildcard)) then
                                exclude=1;
                            end
                        end
                    end

                    if(exclude==1) then
                        if(wildcard~="") then
                            wildcard=" (wildcard "..wildcard..")";
                        end
                        bsInform(OFCC..itemName..PFCC.." "..wildcard.." (found in exclude list) "..RFCC.."(not sold) ");
                    else

                        if(bIsQuestItem==1) then
                            bsInform(OFCC..itemName..GFCC.." (quest item) "..RFCC.."(not sold)");
                        elseif (itemSellPrice==0) then
                            bsInform(OFCC..itemName..BFCC.." (no sell price)"..RFCC.." (not sold)");
                        else
                            wildcard="";
                            if (itemRarity==0) then -- Sell Grey Items but exclude specific items

                                bDoSell=1;

                            else

                                if(db.AutoSell["GreyOnly"]~=1) then

                                    if(db.AutoSell["Remember"]==1) then

                                        for item,_ in pairs (db.AutoSell["Items"]) do
                                            wildcard="";
                                            for what in string.gmatch(item,"(.+)*") do
                                                if(what~=nil) then
                                                    wildcard=what
                                                end
                                            end
                                            if(wildcard~="") then
                                                if(string.find(itemName,wildcard)) then
                                                    bsInform("Sold: "..itemName.. " because it is in your Auto Sell List (wildcard "..wildcard..")");
                                                    bDoSell=1;
                                                end
                                            end
                                        end

                                        for item,_ in pairs (db.AutoSell["Items"]) do
                                            if( itemName == item) then
                                                bsInform("Sold: "..item.. " because it is in your Auto Sell List");
                                                bDoSell=1;
                                            end
                                        end
                                    end

                                    if(db.AutoSell["Soulbound"]==1) then
                                        if(bIsSoulbound==1) then
                                            if(tonumber(iLevel)     >     tonumber(db.AutoSell["SoulboundLow"])) then
                                                if(tonumber(iLevel) <     tonumber(db.AutoSell["SoulboundHigh"])) then
                                                    bsInform("Sold: "..itemName.." because it is soulbound between level "..
                                                        db.AutoSell["SoulboundLow"].." and "..db.AutoSell["SoulboundHigh"]);

                                                    bDoSell=1;
                                                end
                                            end
                                        end
                                    end

                                    if(db.AutoSell["LowFoods"]==1) then

                                        ifoodrange=UnitLevel("player")-itemMinLevel;

                                        --bsInform(itemName.."  TYPE: "..itemSubType.." foodrange="..ifoodrange);

                                        isfood=0;

                                        for wtf in string.gmatch(itemSubType,"Food(.+)") do
                                            isfood=1;
                                        end

                                        if(isfood==1) then

                                            dofood=0;
                                            if  (itemMinLevel==70) or
                                                (itemMinLevel==60) then
                                                if (ifoodrange>5) then
                                                    dofood=1;
                                                end
                                            else
                                                if (ifoodrange>10) then
                                                    dofood=1;
                                                end
                                            end
                                            if(dofood==1) then

                                                if(bHasFoodBuf==0) then
                                                    bsInform("Sold: "..OFCC..itemName..YFCC.."(outleveled food or drink item)");
                                                    bDoSell=1;
                                                else
                                                    if(db.AutoSell["BufFoods"]==1) then
                                                        bDoSell=1;
                                                        bsInform("Sold: "..OFCC..itemName..YFCC.." (outleveled food or drink item with buf)");
                                                    else
                                                        bsInform(OFCC..itemName..JFCC.." (buff food)"..RFCC.." (not sold)");
                                                    end
                                                end
                                            end
                                        end
                                    end
                                end
                            end
                        end
                    end
				end


                if(bDoSell==1) then
                    UseContainerItem(bag,slot);
                    itotalgold=itotalgold+(itemSellPrice*itemCount);
                    safecount=safecount+1;
                end


			end
		end
	end

	if (itotalgold>0) then
        bsInform("Total money earned for auto selling items "..GetCoinText(itotalgold));
    end
    bAutoSellActive=false;
end


function bsSellOneItem(name)

end


function bsRemoveSellItem(itemName)
    if(db.AutoSell["Items"][itemName]~=nil) then
        bsInform("Removed "..itemName.." from sell list");
        db.AutoSell["Items"][itemName]=nil;
    end
end

function bsAddSellItem(inlink)
    if(inlink~=nil) then
        local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(inlink);
        if(itemRarity>0) then
            if(db.AutoSell["Items"][itemName]==1) then
            else
                bsInform("Adding ["..itemName.."] to sell list");
                db.AutoSell["Items"][itemName] = 1;
            end
        end
    end
end

function bsRemoveExcludeItem(itemName)
    if(db.AutoSell["Exclude"][itemName]~=nil) then
        bsInform("Removing "..itemName.." from sell exclude list");
        db.AutoSell["Exclude"][itemName]=nil;
    end
end

function bsAddExcludeItem(inlink)
    if(inlink~=nil) then
        local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(inlink);
        bsDPrint("ITEM EXCLUDE: "..itemName);
        if(db.AutoSell["Exclude"][itemName]==1) then
        else
            bsInform("Adding ["..itemName.."] to exclude list.");
            db.AutoSell["Exclude"][itemName] = 1;
        end
    end
end

function bsASLCreateButtons()
    local createFrame = CreateFrame;
    local parent      = BSASLFrame;
    local button      = createFrame("Button", "BSASLSF_ItemButton1",
                                     parent,  "BSASLSFButtonTemplate");
    button:SetID(1);
    button:SetPoint("TOPLEFT","BSASLFrame","TOPLEFT",36,-75);
    button:RegisterForClicks("LeftButtonUp", "RightButtonUp");

    for index = 2, 23 do
        bsDPrint("BUTTON CREATION: "..index);
        button = createFrame( "Button", "BSASLSF_ItemButton"..index, parent, "BSASLSFButtonTemplate");
        button:SetID(index);
        button:SetPoint( "TOPLEFT", "BSASLSF_ItemButton"..(index-1), "BOTTOMLEFT", 0, 1);
        button:RegisterForClicks( "LeftButtonUp", "RightButtonUp");
    end
end

function bsASLPopulate()

    for index = 1,23 do getglobal("BSASLSF_ItemButton"..index):Hide(); end

	bsDPrint("ASL Pop");

	BSASLSF.RealResultsSize=bsASLGetNumItems();
	BSASLFrameTitleText:SetText("Auto Sell List "..BSASLSF.RealResultsSize.." items");

	FauxScrollFrame_Update(BSASLSF,BSASLSF.RealResultsSize-1,22,16);
	bsDPrint("BSASLSF.RealResultsSize ["..BSASLSF.RealResultsSize.."]");
	local offset = BSASLSF.offset;
	bsDPrint("BSASLSF.offset="..offset);

    local index=1;
    local grof=0;

    -- table.sort(db.AutoSell["Items"]);
    --[[
for i = 1,n,1 do -- for each item of the table
	index_min = i;
	for j = i+1,n,1 do -- for each item of the table, is it the smallest one ?
		if (t[j] < t[index_min]) then index_min = j; end; -- yes : then keep the position
	end;
	t[i], t[index_min] = t[index_min], t[i]; -- swap current item with the smallest one we found
end
]]--
	for bsaslitem,astable in pairs (db.AutoSell["Items"]) do
		if(grof<offset) then
			grof=grof+1;
		else
            bsDPrint("BSASLSF_ItemButton"..index.." RESULT :"..bsaslitem);
			local zbutton=getglobal("BSASLSF_ItemButton"..index);
			if(zbutton~=nil) then
                zwhat=getglobal("BSASLSF_ItemButton"..index.."_Text");
                zwhat:SetText(bsaslitem);
				zbutton:SetScript("OnClick", (function(self) bsASLButtonPressed(bsaslitem); end));
				index=index+1;
				zbutton:Show();
            else
                bsDPrint("ERROR: zbutton==nil BestSeller.lua Line 178");
            end

		end
	end
end

function bsASLGetNumItems()
    if(db.AutoSell==nil) then db.AutoSell={}; end
    if(db.AutoSell["Items"]==nil) then db.AutoSell["Items"]={}; end
	local numitems=0;
	for item,_ in pairs (db.AutoSell["Items"]) do
		numitems=numitems+1;
	end
	return numitems;

end

function bsASLButtonPressed(index)
	bsDPrint("Auto Sell List "..index);
    bsRemoveSellItem(index);
    bsASLPopulate();
end

function bsASLEditBoxAdd()
    if(BSASLFrameAddItemBox:GetText()~="") then
        db.AutoSell["Items"][BSASLFrameAddItemBox:GetText()] = 1;
        bsInform("Added "..BSASLFrameAddItemBox:GetText().." to auto sell list");
        bsASLPopulate();
        BSASLFrameAddItemBox:SetText("");
        BSASLFrameAddItemBox:ClearFocus();
    end
end

function bsEXLCreateButtons()
    local createFrame = CreateFrame;
    local parent      = BSEXLFrame;
    local button      = createFrame("Button", "BSEXLSF_ItemButton1", parent,  "BSASLSFButtonTemplate");
    button:SetID(1);
    button:SetPoint("TOPLEFT","BSEXLFrame","TOPLEFT",36,-75);
    button:RegisterForClicks("LeftButtonUp", "RightButtonUp");

    for index = 2, 23 do
        bsDPrint("BUTTON CREATION: "..index);
        button = createFrame( "Button", "BSEXLSF_ItemButton"..index, parent, "BSASLSFButtonTemplate");
        button:SetID(index);
        button:SetPoint( "TOPLEFT", "BSEXLSF_ItemButton"..(index-1), "BOTTOMLEFT", 0, 1);
        button:RegisterForClicks( "LeftButtonUp", "RightButtonUp");
    end
end

function bsEXLPopulate()

    for index = 1,23 do
        local what=getglobal("BSEXLSF_ItemButton"..index);
        if (what) then
            what:Hide();
        end
    end
	bsDPrint("EXL Pop");
	BSEXLSF.RealResultsSize=bsEXLGetNumItems();
	BSEXLFrameTitleText:SetText("Auto Sell Exclude List "..BSEXLSF.RealResultsSize.." items");
	FauxScrollFrame_Update(BSEXLSF,BSEXLSF.RealResultsSize-1,22,16);
	bsDPrint("BSEXLSF.RealResultsSize ["..BSEXLSF.RealResultsSize.."]");
	local offset = BSEXLSF.offset;
	bsDPrint("BSEXLSF.offset="..offset);
    local index=1;
    local grof=0;

	for bsaslitem,astable in pairs (db.AutoSell["Exclude"]) do
		if(grof<offset) then
			grof=grof+1;
		else
            bsDPrint("BSEXLSF_ItemButton"..index.." RESULT :"..bsaslitem);
			local zbutton=getglobal("BSEXLSF_ItemButton"..index);
			if(zbutton~=nil) then
                zwhat=getglobal("BSEXLSF_ItemButton"..index.."_Text");
                zwhat:SetText(bsaslitem);
				zbutton:SetScript("OnClick", (function(self) bsEXLButtonPressed(bsaslitem); end));
				index=index+1;
				zbutton:Show();
            else
                bsDPrint("ERROR: zbutton==nil BestSeller.lua Line 178");
            end

		end
	end
end

function bsEXLGetNumItems()
	local numitems=0;
	for item,_ in pairs (db.AutoSell["Exclude"]) do
		numitems=numitems+1;
	end
	return numitems;

end

function bsEXLButtonPressed(index)
	bsDPrint("Exclude List "..index);
    bsRemoveExcludeItem(index);
    bsEXLPopulate();
end

function bsEXLEditBoxAdd()
    if(BSEXLFrameAddItemBox:GetText()~="") then
        db.AutoSell["Exclude"][BSEXLFrameAddItemBox:GetText()] = 1;
        bsInform("Added "..BSEXLFrameAddItemBox:GetText().." to exclude list");
        bsEXLPopulate();
        BSEXLFrameAddItemBox:SetText("");
        BSEXLFrameAddItemBox:ClearFocus();
    end
end


